// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "InterferenceFunction1DLattice.pypp.h"

namespace bp = boost::python;

struct InterferenceFunction1DLattice_wrapper : InterferenceFunction1DLattice, bp::wrapper< InterferenceFunction1DLattice > {

    InterferenceFunction1DLattice_wrapper(double length, double xi )
    : InterferenceFunction1DLattice( length, xi )
      , bp::wrapper< InterferenceFunction1DLattice >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::InterferenceFunction1DLattice * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->InterferenceFunction1DLattice::clone(  );
        }
    }
    
    ::InterferenceFunction1DLattice * default_clone(  ) const  {
        return InterferenceFunction1DLattice::clone( );
    }

    virtual double evaluate( ::kvector_t const & q ) const  {
        if( bp::override func_evaluate = this->get_override( "evaluate" ) )
            return func_evaluate( boost::ref(q) );
        else{
            return this->InterferenceFunction1DLattice::evaluate( boost::ref(q) );
        }
    }
    
    double default_evaluate( ::kvector_t const & q ) const  {
        return InterferenceFunction1DLattice::evaluate( boost::ref(q) );
    }

    virtual ::ISample * cloneInvertB(  ) const  {
        if( bp::override func_cloneInvertB = this->get_override( "cloneInvertB" ) )
            return func_cloneInvertB(  );
        else{
            return this->ISample::cloneInvertB(  );
        }
    }
    
    ::ISample * default_cloneInvertB(  ) const  {
        return ISample::cloneInvertB( );
    }

    virtual bool containsMagneticMaterial(  ) const  {
        if( bp::override func_containsMagneticMaterial = this->get_override( "containsMagneticMaterial" ) )
            return func_containsMagneticMaterial(  );
        else{
            return this->ISample::containsMagneticMaterial(  );
        }
    }
    
    bool default_containsMagneticMaterial(  ) const  {
        return ISample::containsMagneticMaterial( );
    }

    virtual ::std::vector< const ISample* > getChildren(  ) const  {
        if( bp::override func_getChildren = this->get_override( "getChildren" ) )
            return func_getChildren(  );
        else{
            return this->ISample::getChildren(  );
        }
    }
    
    ::std::vector< const ISample* > default_getChildren(  ) const  {
        return ISample::getChildren( );
    }

    virtual double getKappa(  ) const  {
        if( bp::override func_getKappa = this->get_override( "getKappa" ) )
            return func_getKappa(  );
        else{
            return this->IInterferenceFunction::getKappa(  );
        }
    }
    
    double default_getKappa(  ) const  {
        return IInterferenceFunction::getKappa( );
    }

    virtual double getParticleDensity(  ) const  {
        if( bp::override func_getParticleDensity = this->get_override( "getParticleDensity" ) )
            return func_getParticleDensity(  );
        else{
            return this->IInterferenceFunction::getParticleDensity(  );
        }
    }
    
    double default_getParticleDensity(  ) const  {
        return IInterferenceFunction::getParticleDensity( );
    }

    virtual void printSampleTree(  ) {
        if( bp::override func_printSampleTree = this->get_override( "printSampleTree" ) )
            func_printSampleTree(  );
        else{
            this->ISample::printSampleTree(  );
        }
    }
    
    void default_printSampleTree(  ) {
        ISample::printSampleTree( );
    }

    virtual ::size_t size(  ) const  {
        if( bp::override func_size = this->get_override( "size" ) )
            return func_size(  );
        else{
            return this->ISample::size(  );
        }
    }
    
    ::size_t default_size(  ) const  {
        return ISample::size( );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_InterferenceFunction1DLattice_class(){

    { //::InterferenceFunction1DLattice
        typedef bp::class_< InterferenceFunction1DLattice_wrapper, bp::bases< IInterferenceFunction >, std::auto_ptr< InterferenceFunction1DLattice_wrapper >, boost::noncopyable > InterferenceFunction1DLattice_exposer_t;
        InterferenceFunction1DLattice_exposer_t InterferenceFunction1DLattice_exposer = InterferenceFunction1DLattice_exposer_t( "InterferenceFunction1DLattice", "Interference function of 1D lattic.", bp::init< double, double >(( bp::arg("length"), bp::arg("xi") ), "constructor.\n\n:Parameters:\n  - 'lattice_params' - Lattice parameters\n  - 'length' - Lattice length\n  - 'xi' - rotation of lattice with respect to x-axis\n") );
        bp::scope InterferenceFunction1DLattice_scope( InterferenceFunction1DLattice_exposer );
        { //::InterferenceFunction1DLattice::clone
        
            typedef ::InterferenceFunction1DLattice * ( ::InterferenceFunction1DLattice::*clone_function_type)(  ) const;
            typedef ::InterferenceFunction1DLattice * ( InterferenceFunction1DLattice_wrapper::*default_clone_function_type)(  ) const;
            
            InterferenceFunction1DLattice_exposer.def( 
                "clone"
                , clone_function_type(&::InterferenceFunction1DLattice::clone)
                , default_clone_function_type(&InterferenceFunction1DLattice_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::InterferenceFunction1DLattice::evaluate
        
            typedef double ( ::InterferenceFunction1DLattice::*evaluate_function_type)( ::kvector_t const & ) const;
            typedef double ( InterferenceFunction1DLattice_wrapper::*default_evaluate_function_type)( ::kvector_t const & ) const;
            
            InterferenceFunction1DLattice_exposer.def( 
                "evaluate"
                , evaluate_function_type(&::InterferenceFunction1DLattice::evaluate)
                , default_evaluate_function_type(&InterferenceFunction1DLattice_wrapper::default_evaluate)
                , ( bp::arg("q") ) );
        
        }
        { //::InterferenceFunction1DLattice::getDecayFunction
        
            typedef ::IFTDecayFunction1D const * ( ::InterferenceFunction1DLattice::*getDecayFunction_function_type)(  ) const;
            
            InterferenceFunction1DLattice_exposer.def( 
                "getDecayFunction"
                , getDecayFunction_function_type( &::InterferenceFunction1DLattice::getDecayFunction )
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::InterferenceFunction1DLattice::getLatticeParameters
        
            typedef ::Lattice1DParameters ( ::InterferenceFunction1DLattice::*getLatticeParameters_function_type)(  ) const;
            
            InterferenceFunction1DLattice_exposer.def( 
                "getLatticeParameters"
                , getLatticeParameters_function_type( &::InterferenceFunction1DLattice::getLatticeParameters ) );
        
        }
        { //::InterferenceFunction1DLattice::setDecayFunction
        
            typedef void ( ::InterferenceFunction1DLattice::*setDecayFunction_function_type)( ::IFTDecayFunction1D const & ) ;
            
            InterferenceFunction1DLattice_exposer.def( 
                "setDecayFunction"
                , setDecayFunction_function_type( &::InterferenceFunction1DLattice::setDecayFunction )
                , ( bp::arg("pdf") ) );
        
        }
        { //::ISample::cloneInvertB
        
            typedef ::ISample * ( ::ISample::*cloneInvertB_function_type)(  ) const;
            typedef ::ISample * ( InterferenceFunction1DLattice_wrapper::*default_cloneInvertB_function_type)(  ) const;
            
            InterferenceFunction1DLattice_exposer.def( 
                "cloneInvertB"
                , cloneInvertB_function_type(&::ISample::cloneInvertB)
                , default_cloneInvertB_function_type(&InterferenceFunction1DLattice_wrapper::default_cloneInvertB)
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::ISample::containsMagneticMaterial
        
            typedef bool ( ::ISample::*containsMagneticMaterial_function_type)(  ) const;
            typedef bool ( InterferenceFunction1DLattice_wrapper::*default_containsMagneticMaterial_function_type)(  ) const;
            
            InterferenceFunction1DLattice_exposer.def( 
                "containsMagneticMaterial"
                , containsMagneticMaterial_function_type(&::ISample::containsMagneticMaterial)
                , default_containsMagneticMaterial_function_type(&InterferenceFunction1DLattice_wrapper::default_containsMagneticMaterial) );
        
        }
        { //::ISample::getChildren
        
            typedef ::std::vector< const ISample* > ( ::ISample::*getChildren_function_type)(  ) const;
            typedef ::std::vector< const ISample* > ( InterferenceFunction1DLattice_wrapper::*default_getChildren_function_type)(  ) const;
            
            InterferenceFunction1DLattice_exposer.def( 
                "getChildren"
                , getChildren_function_type(&::ISample::getChildren)
                , default_getChildren_function_type(&InterferenceFunction1DLattice_wrapper::default_getChildren) );
        
        }
        { //::IInterferenceFunction::getKappa
        
            typedef double ( ::IInterferenceFunction::*getKappa_function_type)(  ) const;
            typedef double ( InterferenceFunction1DLattice_wrapper::*default_getKappa_function_type)(  ) const;
            
            InterferenceFunction1DLattice_exposer.def( 
                "getKappa"
                , getKappa_function_type(&::IInterferenceFunction::getKappa)
                , default_getKappa_function_type(&InterferenceFunction1DLattice_wrapper::default_getKappa) );
        
        }
        { //::IInterferenceFunction::getParticleDensity
        
            typedef double ( ::IInterferenceFunction::*getParticleDensity_function_type)(  ) const;
            typedef double ( InterferenceFunction1DLattice_wrapper::*default_getParticleDensity_function_type)(  ) const;
            
            InterferenceFunction1DLattice_exposer.def( 
                "getParticleDensity"
                , getParticleDensity_function_type(&::IInterferenceFunction::getParticleDensity)
                , default_getParticleDensity_function_type(&InterferenceFunction1DLattice_wrapper::default_getParticleDensity) );
        
        }
        { //::ISample::printSampleTree
        
            typedef void ( ::ISample::*printSampleTree_function_type)(  ) ;
            typedef void ( InterferenceFunction1DLattice_wrapper::*default_printSampleTree_function_type)(  ) ;
            
            InterferenceFunction1DLattice_exposer.def( 
                "printSampleTree"
                , printSampleTree_function_type(&::ISample::printSampleTree)
                , default_printSampleTree_function_type(&InterferenceFunction1DLattice_wrapper::default_printSampleTree) );
        
        }
        { //::ISample::size
        
            typedef ::size_t ( ::ISample::*size_function_type)(  ) const;
            typedef ::size_t ( InterferenceFunction1DLattice_wrapper::*default_size_function_type)(  ) const;
            
            InterferenceFunction1DLattice_exposer.def( 
                "size"
                , size_function_type(&::ISample::size)
                , default_size_function_type(&InterferenceFunction1DLattice_wrapper::default_size) );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( InterferenceFunction1DLattice_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            InterferenceFunction1DLattice_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&InterferenceFunction1DLattice_wrapper::default_transferToCPP) );
        
        }
    }

}
