// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "RotationX.pypp.h"

namespace bp = boost::python;

struct RotationX_wrapper : RotationX, bp::wrapper< RotationX > {

    RotationX_wrapper(double angle )
    : RotationX( angle )
      , bp::wrapper< RotationX >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::RotationX * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->RotationX::clone(  );
        }
    }
    
    ::RotationX * default_clone(  ) const  {
        return RotationX::clone( );
    }

    virtual ::RotationX * cloneInvertB(  ) const  {
        if( bp::override func_cloneInvertB = this->get_override( "cloneInvertB" ) )
            return func_cloneInvertB(  );
        else{
            return this->RotationX::cloneInvertB(  );
        }
    }
    
    ::RotationX * default_cloneInvertB(  ) const  {
        return RotationX::cloneInvertB( );
    }

    virtual ::RotationX * createInverse(  ) const  {
        if( bp::override func_createInverse = this->get_override( "createInverse" ) )
            return func_createInverse(  );
        else{
            return this->RotationX::createInverse(  );
        }
    }
    
    ::RotationX * default_createInverse(  ) const  {
        return RotationX::createInverse( );
    }

    virtual ::Geometry::Transform3D getTransform3D(  ) const  {
        if( bp::override func_getTransform3D = this->get_override( "getTransform3D" ) )
            return func_getTransform3D(  );
        else{
            return this->RotationX::getTransform3D(  );
        }
    }
    
    ::Geometry::Transform3D default_getTransform3D(  ) const  {
        return RotationX::getTransform3D( );
    }

    virtual bool containsMagneticMaterial(  ) const  {
        if( bp::override func_containsMagneticMaterial = this->get_override( "containsMagneticMaterial" ) )
            return func_containsMagneticMaterial(  );
        else{
            return this->ISample::containsMagneticMaterial(  );
        }
    }
    
    bool default_containsMagneticMaterial(  ) const  {
        return ISample::containsMagneticMaterial( );
    }

    virtual ::std::vector< const ISample* > getChildren(  ) const  {
        if( bp::override func_getChildren = this->get_override( "getChildren" ) )
            return func_getChildren(  );
        else{
            return this->ISample::getChildren(  );
        }
    }
    
    ::std::vector< const ISample* > default_getChildren(  ) const  {
        return ISample::getChildren( );
    }

    virtual bool isIdentity(  ) const  {
        if( bp::override func_isIdentity = this->get_override( "isIdentity" ) )
            return func_isIdentity(  );
        else{
            return this->IRotation::isIdentity(  );
        }
    }
    
    bool default_isIdentity(  ) const  {
        return IRotation::isIdentity( );
    }

    virtual void printSampleTree(  ) {
        if( bp::override func_printSampleTree = this->get_override( "printSampleTree" ) )
            func_printSampleTree(  );
        else{
            this->ISample::printSampleTree(  );
        }
    }
    
    void default_printSampleTree(  ) {
        ISample::printSampleTree( );
    }

    virtual ::size_t size(  ) const  {
        if( bp::override func_size = this->get_override( "size" ) )
            return func_size(  );
        else{
            return this->ISample::size(  );
        }
    }
    
    ::size_t default_size(  ) const  {
        return ISample::size( );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_RotationX_class(){

    { //::RotationX
        typedef bp::class_< RotationX_wrapper, bp::bases< IRotation >, std::auto_ptr< RotationX_wrapper >, boost::noncopyable > RotationX_exposer_t;
        RotationX_exposer_t RotationX_exposer = RotationX_exposer_t( "RotationX", bp::init< double >(( bp::arg("angle") )) );
        bp::scope RotationX_scope( RotationX_exposer );
        { //::RotationX::clone
        
            typedef ::RotationX * ( ::RotationX::*clone_function_type)(  ) const;
            typedef ::RotationX * ( RotationX_wrapper::*default_clone_function_type)(  ) const;
            
            RotationX_exposer.def( 
                "clone"
                , clone_function_type(&::RotationX::clone)
                , default_clone_function_type(&RotationX_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::RotationX::cloneInvertB
        
            typedef ::RotationX * ( ::RotationX::*cloneInvertB_function_type)(  ) const;
            typedef ::RotationX * ( RotationX_wrapper::*default_cloneInvertB_function_type)(  ) const;
            
            RotationX_exposer.def( 
                "cloneInvertB"
                , cloneInvertB_function_type(&::RotationX::cloneInvertB)
                , default_cloneInvertB_function_type(&RotationX_wrapper::default_cloneInvertB)
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::RotationX::createInverse
        
            typedef ::RotationX * ( ::RotationX::*createInverse_function_type)(  ) const;
            typedef ::RotationX * ( RotationX_wrapper::*default_createInverse_function_type)(  ) const;
            
            RotationX_exposer.def( 
                "createInverse"
                , createInverse_function_type(&::RotationX::createInverse)
                , default_createInverse_function_type(&RotationX_wrapper::default_createInverse)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::RotationX::getAngle
        
            typedef double ( ::RotationX::*getAngle_function_type)(  ) const;
            
            RotationX_exposer.def( 
                "getAngle"
                , getAngle_function_type( &::RotationX::getAngle ) );
        
        }
        { //::RotationX::getTransform3D
        
            typedef ::Geometry::Transform3D ( ::RotationX::*getTransform3D_function_type)(  ) const;
            typedef ::Geometry::Transform3D ( RotationX_wrapper::*default_getTransform3D_function_type)(  ) const;
            
            RotationX_exposer.def( 
                "getTransform3D"
                , getTransform3D_function_type(&::RotationX::getTransform3D)
                , default_getTransform3D_function_type(&RotationX_wrapper::default_getTransform3D) );
        
        }
        { //::ISample::containsMagneticMaterial
        
            typedef bool ( ::ISample::*containsMagneticMaterial_function_type)(  ) const;
            typedef bool ( RotationX_wrapper::*default_containsMagneticMaterial_function_type)(  ) const;
            
            RotationX_exposer.def( 
                "containsMagneticMaterial"
                , containsMagneticMaterial_function_type(&::ISample::containsMagneticMaterial)
                , default_containsMagneticMaterial_function_type(&RotationX_wrapper::default_containsMagneticMaterial) );
        
        }
        { //::ISample::getChildren
        
            typedef ::std::vector< const ISample* > ( ::ISample::*getChildren_function_type)(  ) const;
            typedef ::std::vector< const ISample* > ( RotationX_wrapper::*default_getChildren_function_type)(  ) const;
            
            RotationX_exposer.def( 
                "getChildren"
                , getChildren_function_type(&::ISample::getChildren)
                , default_getChildren_function_type(&RotationX_wrapper::default_getChildren) );
        
        }
        { //::IRotation::isIdentity
        
            typedef bool ( ::IRotation::*isIdentity_function_type)(  ) const;
            typedef bool ( RotationX_wrapper::*default_isIdentity_function_type)(  ) const;
            
            RotationX_exposer.def( 
                "isIdentity"
                , isIdentity_function_type(&::IRotation::isIdentity)
                , default_isIdentity_function_type(&RotationX_wrapper::default_isIdentity) );
        
        }
        { //::ISample::printSampleTree
        
            typedef void ( ::ISample::*printSampleTree_function_type)(  ) ;
            typedef void ( RotationX_wrapper::*default_printSampleTree_function_type)(  ) ;
            
            RotationX_exposer.def( 
                "printSampleTree"
                , printSampleTree_function_type(&::ISample::printSampleTree)
                , default_printSampleTree_function_type(&RotationX_wrapper::default_printSampleTree) );
        
        }
        { //::ISample::size
        
            typedef ::size_t ( ::ISample::*size_function_type)(  ) const;
            typedef ::size_t ( RotationX_wrapper::*default_size_function_type)(  ) const;
            
            RotationX_exposer.def( 
                "size"
                , size_function_type(&::ISample::size)
                , default_size_function_type(&RotationX_wrapper::default_size) );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( RotationX_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            RotationX_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&RotationX_wrapper::default_transferToCPP) );
        
        }
    }

}
